Procedure SetPcxPalette (Screen : Integer; Pal : PcxPalette);
Var P                   : PaletteType;
    I, J, BkCol, CgaPal : Integer;
    C                   : Real;
    B, BB               : ShortInt;
Begin
  GetDefaultPalette (P);
  Case Screen of
    0 : Begin
      For I := 0 To P.Size - 1 Do
        Begin
          B := 0;
          For J := 0 To 2 Do
            Begin
              C := Pal [I, J];
              BB := Trunc (C / 255.0 * 3.0);
              Case J of
                0 : Begin
                  If (BB and 1) > 0 Then B := B or $20;
                  If (BB and 2) > 0 Then B := B or $04
                End;
                1 : Begin
                  If (BB and 1) > 0 Then B := B or $10;
                  If (BB and 2) > 0 Then B := B or $02
                End;
                2 : Begin
                  If (BB and 1) > 0 Then B := B or $08;
                  If (BB and 2) > 0 Then B := B or $01
                End
              End
            End;
          P.Colors [I] := B
        End;
      SetAllPalette (P)
    End;
    2 : Begin
      BkCol := (Pal [0, 0] div $10) mod 8;
      CgaPal := (Pal [1, 0] div $20) mod 4;
      SetBkColor (BkCol);
      SetGraphMode (CgaPal)
    End
  End
End;
